/***************************************************************************
 *Copyright (C) 2008 Inventec Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 **************************************************************************/
#ifndef THREEG_ENCLUDED
#include "threeg.h"
#endif
int k,t;
int threeg=1;
int prv_3g,now_3g;
int read_kill_switch(void);
int read_3g(void);
void set_3g(int x);
int threeg_open(struct inode *node, struct file *filp){
	return 0;
}
int threeg_release(struct inode *node, struct file *filp){
	return 0;
}

ssize_t threeg_read (struct file *filp, char __user *buff, size_t count, loff_t *fpos){
	buff[0]=read_3g();
	return 0;
}

ssize_t threeg_write (struct file *filp, const char __user *buff, size_t count, loff_t *fpos){
	if(read_kill_switch()==1 && (read_device()&16)!=0){
		prv_3g=read_3g();
		set_3g((prv_3g+1)%2);
		//set_current_state(TASK_UNINTERRUPTIBLE);
		//schedule_timeout(50);
		//now_3g=read_3g();
		return (prv_3g+1)%2;
	}
	else{
		//return -EFAULT;
		return -1;
	}
}

int read_3g(void){
        outb(0xd0, 0x72);
        outb(0xd0, 0x73);
        outb(0xd1, 0x72);
        outb(0x00, 0x73);
        outb(0xd2, 0x72);
        outb(0x00, 0x73);
        outb(0xd3, 0x72);
        outb(0x00, 0x73);
        outb(0xd4, 0x72);
        outb(0x00, 0x73);
        outb(0xe5, 0xb2);
        outb(0xd0, 0x72);
        while(inb(0x73)!=0){}
        outb(0xd1,0x72);
	return inb(0x73);
}
void set_3g(int x){
for (k=0;k<3;k++){
        outb(0xd0, 0x72);
        outb(0xd0, 0x73);
        outb(0xd1, 0x72);
        outb(0x01, 0x73);
        outb(0xd2, 0x72);
        outb(x, 0x73);
        outb(0xd3, 0x72);
        outb(0x00, 0x73);
        outb(0xd4, 0x72);
        outb(0x00, 0x73);
        outb(0xe5, 0xb2);
        outb(0xd0, 0x72);
        while(inb(0x73)!=0){}
}
}
