/***************************************************************************
 *Copyright (C) 2008 Inventec Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 **************************************************************************/
#ifndef WIRELESS_INCLUDED
#include "wireless.h"
#endif
int i;
int wireless=1;
int read_kill_switch(void);
void set_kill_switch(int x);
int wireless_prv,wireless_now;
int wireless_open(struct inode *node, struct file *filp){
	return 0;
}
int wireless_release(struct inode *node, struct file *filp){
	return 0;
}

ssize_t wireless_read (struct file *filp, char __user *buff, size_t count, loff_t *fpos){
	if ((read_device() & 4)==0){
		return -1;
	}
	else{
		buff[0]=read_kill_switch();
		return 0;
	}	
}

ssize_t wireless_write (struct file *filp, const char __user *buff, size_t count, loff_t *fpos){
	if ((read_device() & 4)==0){
		return -1;
	}
	else{
		wireless_prv=read_kill_switch();
		set_kill_switch((wireless_prv+1)%2);
		wireless_now=read_kill_switch();
		if(wireless_now==wireless_prv){
			return -1;
		}
		else{
			return wireless_now;
		}
	}
}

int read_kill_switch(){
	//set_current_state(TASK_UNINTERRUPTIBLE);
	//schedule_timeout(5);
        outb(0xd0, 0x72);
        outb(0xa4, 0x73);
        outb(0xd1, 0x72);
        outb(0x00, 0x73);

        outb(0xe5, 0xb2);
	outb(0xd0, 0x72);
	while(inb(0x73)!=0){}
        outb(0xd1, 0x72);
        return inb(0x73);
}

void set_kill_switch(int x){
	outb(0xd0, 0x72);
	outb(0xa4, 0x73);
	outb(0xd1, 0x72);
	outb(0x01, 0x73);
	outb(0xd2, 0x72);
	outb(x, 0x73);
	outb(0xe5, 0xb2);
	outb(0xd0, 0x72);
	while(inb(0x73)!=0){}
	set_current_state(TASK_UNINTERRUPTIBLE);
	schedule_timeout(50);
}
int read_device(){
        outb(0xd0, 0x72);
        outb(0xa6, 0x73);
        outb(0xd1, 0x72);
        outb(0x00, 0x73);
        outb(0xd2, 0x72);
        outb(0x00, 0x73);
        outb(0xd3, 0x72);
        outb(0x00, 0x73);
        outb(0xd4, 0x72);
        outb(0x00, 0x73);
        outb(0xe5, 0xb2);
        outb(0xd0, 0x72);
        while(inb(0x73)!=0){}
        outb(0xd1,0x72);
	return inb(0x73);
}

